﻿using AdventOfCode.Common;
using AdventOfCode.Models;
using AdventOfCode.Common;
using System;
using System.Collections.Generic;
using System.Linq;

namespace AdventOfCode._2022
{
    [AOC(year: 2022, day: 3)]
    public class Day3 : AOCDay
    {
        protected override AOCResponse ExecutePartA()
        {
            var rows = GetSplitInput();
            int total = 0;
            foreach (var row in rows)
            {
                var first = row.Substring(0, row.Length / 2);
                var second = row.Substring((row.Length / 2));
                var invalidItem = first.ToCharArray().Intersect(second.ToCharArray()).First();
                total += GetPriority(invalidItem);
            }
            _response.Answer = total;
            return _response;
        }

        protected override AOCResponse ExecutePartB()
        {
            var rows = GetSplitInput();
            int total = 0;
            foreach (var group in rows.Chunk(3))
            {
                var elf1 = group.ToArray()[0].ToCharArray();
                var elf2 = group.ToArray()[1].ToCharArray();
                var elf3 = group.ToArray()[2].ToCharArray();
                var inter = elf1.Intersect(elf2).Intersect(elf3).First();
                Log("Intersection char is " + inter);
                total += GetPriority(inter);
            }

            _response.Answer = total;
            return _response;
        }

        private int GetPriority(char c)
        {
            if (Char.IsUpper(c))
            {
                return (c - 'A' + 27);
            }
            if (Char.IsLower(c))
            {
                return (c - 'a' + 1);
            }
            return 0;
        }
    }
}
